import asyncio
import json 
 
from databridges_sio_client_lib import dBridges
from databridges_sio_client_lib.exceptions import dBError


class ExampleClass():
    def __init__(self):
        self.bridge = None
        self.weather = None
        self.dbApplnKey = 'appkey';
        self.dbAuthURL = 'auth_url';
        self.city = str(sys.argv[1])
        

    # Bind to disconnected event, to get intimation about dbrdige network disconnection.
    async def disconnected(self):
        print("disconnected:")

    async def current(self):
        try:
            def progress(response):
                print("single", response);

            #  Execute Server function with parameter 'single'. This will  return single data.
            p = await self.weather.call('currentWeather', self.city, 10000, progress)

            def onResult(res):
                #  Response will be received here. As with 'single' parameter Server sends only one stream of data.
                print("single", res)

            def onError(res):
                #  Catch execption for .call
                print("single", res.source, res.code, res.message, )

            p.then(onResult).catch(onError)

        except Exception as dberror:
            print("Exception: ", dberror.source, dberror.code, dberror.message)


   
    # Bind to connected event, Once the dbridge is connected successfully, rpc call and other activities can be performed.
    async def connected(self):
        print("connected:")
        #  Connect to rpcServer
        try:
            self.weather =  await self.dbridge.rpc.connect("weather.now")
        except Exception as dberror:
            print("Exception: ", dberror.source, dberror.code, dberror.message)

        if self.weather!= None:
            #  Bind to event server.connect.success, This will be triggered when the connection to server is successfull
            async def serverconnect_success(payload, metadata):
                print("dbridges:rpc.server.connect.success", payload, metadata)
                #  Execute Server function with parameter 
                await self.current()
            self.weather.bind("dbridges:rpc.server.connect.success", serverconnect_success)

            #  Bind to server.connect.fail. This will be triggered either if connection to rpcServer fails or reconnect fails.
            async def serverconnect_fail(payload, metadata):
                print("dbridges:rpc.server.connect.fail", payload, metadata)
            self.weather.bind("dbridges:rpc.server.connect.fail", serverconnect_fail)

    async def MainExecute(self):
        #  Initialize dbridge client
        self.dbridge = dBridges()
        #  Replace your appliation key below, which you have received from dBridge management portal.
        self.dbridge.auth_url = self.dbAuthURL

        #  Replace your appliation key below, which you have received from dBridge management portal.
        self.dbridge.appkey = self.dbApplnKey
        try:
            self.dbridge.connectionstate.bind("connected", self.connected) 
            self.dbridge.connectionstate.bind("disconnected", self.disconnected)
        except Exception as dberror:
            print("Exception: ", dberror.source, dberror.code, dberror.message)

        #  Connect to dbridge. If any runtime error it will be caught in catch().
        try:
            await self.dbridge.connect()
        except Exception as dberror:
            print("Exception: ", dberror.source, dberror.code, dberror.message)


if __name__ == '__main__':
    try:
        example = ExampleClass()
        asyncio.run(example.MainExecute())
    except Exception as e:
        print(e)
